# Installation
1. Clone the ddos tool

```sh
git clone https://git.420joos.dev/ost/dat505-ethical_hacking/ddos-attack-tool.git
```

2. Navigate into the cloned folder

```sh
cd ddos-attack-tool
```

3. Create a virtual environment (not necessary, but highly recommended)

```sh
virtualenv venv
```

4. Install requirements

```sh
pip install -r requirements.txt
```

5. Use the tool, for example

```sh
ddos --help
```

## Development install
After step 4, the modules must be installed in editable mode by running

```sh
pip install -e ./attacks
pip install -e .
```

# Usage
The usage of the tool can be inspected by executing

```sh
ddos -h
```

Each attack has its own parameters.
They can be checked by running

```sh
ddos {attack} -h
```

For example, to check the parameters for a Smurf attack, execute

```sh
ddos smurf -h
```

or

```sh
ddos s -h
```
